/*
 * Panel application "JinJan"
 */
#include <application.h>
#include <avr/interrupt.h>

/*
 * function prototypes
 */
int jinjan_init(void);

const char jinjan_name_P[] PROGMEM="JinJan";
const char jinjan_icon_P[] PROGMEM={
  18,18,
  2,
  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x01,0x00,0x00,
  0x07,0xc0,0x00,
  0x0f,0x60,0x00,
  0x0f,0xe0,0x00,
  0x1f,0xe0,0x00,
  0x1f,0xc0,0x00,
  0x1f,0x00,0x00,
  0x1e,0x00,0x00,
  0x0e,0x00,0x00,
  0x0e,0x00,0x00,
  0x07,0x00,0x00,
  0x01,0xc0,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00,

  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x00,0xe0,0x00,
  0x00,0x38,0x00,
  0x00,0x1c,0x00,
  0x00,0x1c,0x00,
  0x00,0x1e,0x00,
  0x00,0x3e,0x00,
  0x00,0xfe,0x00,
  0x01,0xfe,0x00,
  0x01,0xfc,0x00,
  0x01,0xbc,0x00,
  0x00,0xf8,0x00,
  0x00,0x20,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00,
  0x00,0x00,0x00
};

struct application JINJAN={jinjan_name_P, jinjan_icon_P, jinjan_init, 0, 0};

void BigPixel(int x, int y, char color)
{
	LEDPixel(x,y,color);
	LEDPixel(x+1,y,color);
	LEDPixel(x,y+1,color);
	LEDPixel(x+1,y+1,color);
}

int jinjan_init(void)
{
	int jin_x, jin_y, jan_x, jan_y;
	char jin_dir, jan_dir, cycle;
	jin_x=rand()%MAXX;
	jin_y=rand()%MAXY;
	jin_dir=0;
	jan_x=rand()%MAXX;
	jan_y=rand()%MAXY;
	jan_dir=0;
	BigPixel(jin_x, jin_y, RED);
	BigPixel(jan_x, jan_y, GREEN);
	cycle=0;
	do
	{
		BigPixel(jin_x, jin_y, BLACK);
	  BigPixel(jan_x, jan_y, BLACK);
		if (!(cycle&3)) jin_dir=rand()%4;
		switch (jin_dir)
		{
			case 0: if (jin_x<MAXX-2) jin_x++ ; else {jin_x--; jin_dir=1;} break; 
			case 1: if (jin_x>0) jin_x-- ; else {jin_x++; jin_dir=0;} break; 
			case 2: if (jin_y<MAXY-2) jin_y++ ; else {jin_y--; jin_dir=3;} break; 
			case 3: if (jin_y>0) jin_y-- ; else {jin_y++; jin_dir=2;} break; 
		}
    if (!(cycle&1))
    {
		  if (!cycle) jan_dir=rand()%4;
		  switch (jan_dir)
		  {
			  case 0: if (jan_x<MAXX-2) jan_x++ ; else {jan_x--; jan_dir=1;} break; 
			  case 1: if (jan_x>0) jan_x-- ; else {jan_x++; jan_dir=0;} break; 
			  case 2: if (jan_y<MAXY-2) jan_y++ ; else {jan_y--; jan_dir=3;} break; 
			  case 3: if (jan_y>0) jan_y-- ; else {jan_y++; jan_dir=2;} break; 
		  }
    }			
		BigPixel(jin_x, jin_y, RED);
	  BigPixel(jan_x, jan_y, GREEN);
		LEDDraw();
		cycle++; if (cycle>7) cycle=0;
	} while ((wait(50)!=3) && !(keypad&(BTN_ACTLEFT+BTN_LEFT)));
  return 0;
}
